%global with_debug 1
%global with_devel 0
%global with_unit_test 0

%if 0%{?fedora} || 0%{?centos}
%global with_check 1
%global with_integration_tests 1
%else
%global with_check 0
%global with_integration_tests 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

#%%if ! 0%%{?gobuild:1}
%define gobuild(o:) go build -tags="$BUILDTAGS rpm_crashtraceback" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
#%%endif

%global provider        github
%global provider_tld    com
%global project         cri-o
%global repo            cri-o
# https://github.com/kubernetes-sigs/cri-o
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global service_name crio

Name:    cri-o
%if 0%{?fedora}
Epoch: 2
%endif
Version: 1.14.7
Release: 1.0.8%{?dist}
Vendor:  Oracle America
Summary: Kubernetes Container Runtime Interface for OCI-based containers
License: Apache-2.0
URL:     https://%{provider_prefix}
Source0: %{name}-%{version}.tar.bz2
Source3: %{service_name}-network.sysconfig
Source4: %{service_name}-storage.sysconfig

# Pieces normally delivered by skopeo-containers
Source5: default-policy.json

ExcludeArch: ppc64
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires: golang >= 1.13.15
BuildRequires: btrfs-progs-devel
BuildRequires: git
BuildRequires: glib2-devel
BuildRequires: glibc-static
BuildRequires: go-md2man
BuildRequires: gpgme-devel
BuildRequires: libassuan-devel
BuildRequires: pkgconfig(systemd)
BuildRequires: device-mapper-devel
BuildRequires: make
Requires(pre): container-selinux
Requires: socat
Requires: iptables
Requires: iproute
Requires: conmon = %{version}-%{release}
Requires: %{_sysconfdir}/cri-tools/1.14
Provides: %{_sysconfdir}/crio/1.14

# This is Oracle name for containernetworking-cni/plugins
Requires: kubernetes-cni-plugins
%if 0%{?fedora}
BuildRequires: libseccomp-static
Requires: runc >= 2:1.0.0-15
#Requires: skopeo-containers >= 0.1.24-6
Provides: %{service_name} = %{epoch}:%{version}-%{release}
Provides: ocid = %{epoch}:%{version}-%{release}
%else
BuildRequires: libseccomp-devel
Requires: runc >= 1.0.0-15
#Requires: skopeo-containers >= 0.1.24-6
Provides: %{service_name} = %{version}-%{release}
Provides: ocid = %{version}-%{release}
%endif
Obsoletes: ocid <= 0.3

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch
Requires:      golang(github.com/BurntSushi/toml)
Requires:      golang(github.com/Microsoft/go-winio)
Requires:      golang(github.com/Sirupsen/logrus)
Requires:      golang(github.com/containernetworking/cni/libcni)
Requires:      golang(github.com/containernetworking/cni/pkg/invoke)
Requires:      golang(github.com/containernetworking/cni/pkg/types)
Requires:      golang(github.com/containernetworking/cni/pkg/version)
Requires:      golang(github.com/containers/image/directory)
Requires:      golang(github.com/containers/image/directory/explicitfilepath)
Requires:      golang(github.com/containers/image/docker)
Requires:      golang(github.com/containers/image/docker/policyconfiguration)
Requires:      golang(github.com/containers/image/image)
Requires:      golang(github.com/containers/image/manifest)
Requires:      golang(github.com/containers/image/oci/layout)
Requires:      golang(github.com/containers/image/openshift)
Requires:      golang(github.com/containers/image/transports)
Requires:      golang(github.com/containers/image/types)
Requires:      golang(github.com/containers/image/version)
Requires:      golang(github.com/docker/distribution)
Requires:      golang(github.com/docker/distribution/context)
Requires:      golang(github.com/docker/distribution/digest)
Requires:      golang(github.com/docker/distribution/reference)
Requires:      golang(github.com/docker/distribution/uuid)
Requires:      golang(github.com/docker/docker/api/types/blkiodev)
Requires:      golang(github.com/docker/docker/api/types/container)
Requires:      golang(github.com/docker/docker/api/types/mount)
Requires:      golang(github.com/docker/docker/api/types/strslice)
Requires:      golang(github.com/docker/docker/api/types/versions)
Requires:      golang(github.com/docker/docker/daemon/graphdriver)
Requires:      golang(github.com/docker/docker/image)
Requires:      golang(github.com/docker/docker/image/v1)
Requires:      golang(github.com/docker/docker/layer)
Requires:      golang(github.com/docker/docker/pkg/archive)
Requires:      golang(github.com/docker/docker/pkg/chrootarchive)
Requires:      golang(github.com/docker/docker/pkg/fileutils)
Requires:      golang(github.com/docker/docker/pkg/homedir)
Requires:      golang(github.com/docker/docker/pkg/idtools)
Requires:      golang(github.com/docker/docker/pkg/ioutils)
Requires:      golang(github.com/docker/docker/pkg/longpath)
Requires:      golang(github.com/docker/docker/pkg/mount)
Requires:      golang(github.com/docker/docker/pkg/plugins)
Requires:      golang(github.com/docker/docker/pkg/plugins/transport)
Requires:      golang(github.com/docker/docker/pkg/pools)
Requires:      golang(github.com/docker/docker/pkg/promise)
Requires:      golang(github.com/docker/docker/pkg/random)
Requires:      golang(github.com/docker/docker/pkg/reexec)
Requires:      golang(github.com/docker/docker/pkg/registrar)
Requires:      golang(github.com/docker/docker/pkg/stringid)
Requires:      golang(github.com/docker/docker/pkg/system)
Requires:      golang(github.com/docker/docker/pkg/truncindex)
Requires:      golang(github.com/docker/docker/plugin/getter)
Requires:      golang(github.com/docker/docker/reference)
Requires:      golang(github.com/docker/go-connections/nat)
Requires:      golang(github.com/docker/go-connections/sockets)
Requires:      golang(github.com/docker/go-connections/tlsconfig)
Requires:      golang(github.com/docker/go-units)
Requires:      golang(github.com/docker/libtrust)
Requires:      golang(github.com/ghodss/yaml)
Requires:      golang(github.com/gogo/protobuf/proto)
Requires:      golang(github.com/golang/glog)
Requires:      golang(github.com/golang/protobuf/proto)
Requires:      golang(github.com/gorilla/context)
Requires:      golang(github.com/gorilla/mux)
Requires:      golang(github.com/imdario/mergo)
Requires:      golang(github.com/opencontainers/image-spec/specs-go)
Requires:      golang(github.com/opencontainers/image-spec/specs-go/v1)
Requires:      golang(github.com/opencontainers/runc/libcontainer/label)
Requires:      golang(github.com/opencontainers/runc/libcontainer/selinux)
Requires:      golang(github.com/opencontainers/runc/libcontainer/system)
Requires:      golang(github.com/opencontainers/runc/libcontainer/user)
Requires:      golang(github.com/opencontainers/runtime-spec/specs-go)
Requires:      golang(github.com/opencontainers/runtime-tools/generate)
Requires:      golang(github.com/rajatchopra/ocicni)
Requires:      golang(github.com/syndtr/gocapability/capability)
Requires:      golang(github.com/tchap/go-patricia/patricia)
Requires:      golang(github.com/vbatts/tar-split/archive/tar)
Requires:      golang(github.com/vbatts/tar-split/tar/asm)
Requires:      golang(github.com/vbatts/tar-split/tar/storage)
Requires:      golang(golang.org/x/net/context)
Requires:      golang(golang.org/x/net/http2)
Requires:      golang(golang.org/x/net/http2/hpack)
Requires:      golang(golang.org/x/net/internal/timeseries)
Requires:      golang(golang.org/x/net/proxy)
Requires:      golang(golang.org/x/net/trace)
Requires:      golang(golang.org/x/sys/unix)
Requires:      golang(google.golang.org/grpc)
Requires:      golang(google.golang.org/grpc/codes)
Requires:      golang(google.golang.org/grpc/credentials)
Requires:      golang(google.golang.org/grpc/grpclog)
Requires:      golang(google.golang.org/grpc/internal)
Requires:      golang(google.golang.org/grpc/metadata)
Requires:      golang(google.golang.org/grpc/naming)
Requires:      golang(google.golang.org/grpc/peer)
Requires:      golang(google.golang.org/grpc/transport)
Requires:      golang(gopkg.in/yaml.v2)
Requires:      golang(k8s.io/kubernetes/pkg/fields)
Requires:      golang(k8s.io/kubernetes/pkg/kubelet/api/v1alpha1/runtime)
Requires:      golang(k8s.io/kubernetes/pkg/selection)
Requires:      golang(k8s.io/kubernetes/pkg/util/errors)
Requires:      golang(k8s.io/kubernetes/pkg/util/homedir)
Requires:      golang(k8s.io/kubernetes/pkg/util/net)
Requires:      golang(k8s.io/kubernetes/pkg/util/sets)

Provides:      golang(%{import_path}/oci) = %{version}-%{release}
Provides:      golang(%{import_path}/server) = %{version}-%{release}
Provides:      golang(%{import_path}/utils) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/BurntSushi/toml)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/Sirupsen/logrus)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containernetworking/cni/libcni)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containernetworking/cni/pkg/invoke)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containernetworking/cni/pkg/types)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containernetworking/cni/pkg/version)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/directory)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/directory/explicitfilepath)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/docker)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/docker/policyconfiguration)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/image)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/manifest)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/oci/layout)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/openshift)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/transports)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/types)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/containers/image/version)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/coreos/go-systemd/daemon)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/distribution)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/distribution/context)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/distribution/digest)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/distribution/reference)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/distribution/uuid)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/api/types/blkiodev)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/api/types/container)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/api/types/mount)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/api/types/strslice)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/api/types/versions)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/daemon/graphdriver)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/image)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/image/v1)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/layer)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/archive)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/chrootarchive)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/fileutils)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/homedir)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/idtools)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/ioutils)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/mount)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/plugins)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/plugins/transport)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/pools)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/promise)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/random)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/reexec)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/registrar)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/stringid)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/system)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/pkg/truncindex)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/plugin/getter)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/docker/reference)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/go-connections/nat)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/go-connections/sockets)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/go-connections/tlsconfig)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/go-units)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/docker/libtrust)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/ghodss/yaml)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/gogo/protobuf/proto)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/golang/glog)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/golang/protobuf/proto)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/gorilla/context)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/gorilla/mux)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/imdario/mergo)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/image-spec/specs-go)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/image-spec/specs-go/v1)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runc/libcontainer/label)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runc/libcontainer/selinux)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runc/libcontainer/system)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runc/libcontainer/user)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runtime-spec/specs-go)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/opencontainers/runtime-tools/generate)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/rajatchopra/ocicni)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/syndtr/gocapability/capability)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/tchap/go-patricia/patricia)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/urfave/cli)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/vbatts/tar-split/archive/tar)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/vbatts/tar-split/tar/asm)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/github.com/vbatts/tar-split/tar/storage)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/net/context)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/net/http2)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/net/http2/hpack)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/net/proxy)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/net/trace)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/golang.org/x/sys/unix)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/codes)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/credentials)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/grpclog)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/metadata)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/naming)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/peer)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/google.golang.org/grpc/transport)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/gopkg.in/yaml.v2)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/fields)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/kubelet/api/v1alpha1/runtime)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/selection)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/util/errors)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/util/homedir)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/util/net)) = %{version}-%{release}
Provides:      bundled(golang(%{import_path}/vendor/src/k8s.io/kubernetes/pkg/util/sets)) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%package -n conmon
Summary: OCI container runtime monitor

%description -n conmon
conmon is an OCI container runtime monitor.

%if 0%{?with_integration_tests}
%package integration-tests
Summary: Integration tests for %{name}
Requires: %{service_name} = %{epoch}:%{version}-%{release}
Requires: bats
Requires: nmap-ncat
Requires: socat

%description integration-tests
%{summary}
%endif

%prep
%setup -q
sed -i '/strip/d' pause/Makefile

%build
mkdir _output
pushd _output
mkdir -p src/%{provider}.%{provider_tld}/{%{project},opencontainers}
ln -s $(dirs +1 -l) src/%{import_path}
popd

ln -s vendor src
export GOPATH=$(pwd)/_output:$(pwd):%{gopath}
export BUILDTAGS="selinux seccomp $(hack/btrfs_installed_tag.sh) $(hack/btrfs_tag.sh) $(hack/libdm_installed.sh) containers_image_ostree_stub"

GOPATH=$GOPATH BUILDTAGS=$BUILDTAGS %gobuild -o bin/%{service_name} %{import_path}/cmd/%{service_name}
BUILDTAGS=$BUILDTAGS make bin/conmon bin/pause docs

./bin/%{service_name} \
  --selinux=true \
  --storage-driver=overlay \
  --conmon %{_libexecdir}/%{service_name}/conmon \
  --cni-plugin-dir /opt/cni/bin/ \
%if 0%{?centos}
  --storage-opt overlay.override_kernel_check=1 \
%endif
  --cgroup-manager=cgroupfs config > %{service_name}.conf%{?dist}

%if 0%{?with_integration_tests}
export GOPATH=$(pwd)/_output
for i in bin2img copyimg checkseccomp; do
    GOPATH=$GOPATH BUILDTAGS=$BUILDTAGS %gobuild -o test/$i/$i %{provider_prefix}/test/$i
done
%endif

%install
# Create a version file so this project can be bounded as a dependency
install -dp %{buildroot}%{_sysconfdir}/%{service_name}
touch %{buildroot}%{_sysconfdir}/%{service_name}/1.14

sed -i 's/\/usr\/local\/bin\/crio/\/usr\/bin\/crio/g' contrib/systemd/%{service_name}.service
make DESTDIR=%{buildroot} PREFIX=%{buildroot}%{_prefix} install.config install.systemd

# install binaries
install -dp %{buildroot}{%{_bindir},%{_libexecdir}/%{service_name}}
install -p -m 755 bin/%{service_name} %{buildroot}%{_bindir}
install -p -m 755 bin/conmon %{buildroot}%{_libexecdir}/%{service_name}
install -p -m 755 bin/pause %{buildroot}%{_libexecdir}/%{service_name}

# install config
install -p -m 644 %{service_name}.conf%{?dist} %{buildroot}%{_sysconfdir}/%{service_name}/%{service_name}.conf

install -dp %{buildroot}%{_sysconfdir}/cni/net.d
install -p -m 644 contrib/cni/10-crio-bridge.conf %{buildroot}%{_sysconfdir}/cni/net.d/100-crio-bridge.conf
install -p -m 644 contrib/cni/99-loopback.conf %{buildroot}%{_sysconfdir}/cni/net.d/200-loopback.conf

install -dp %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{service_name}-network
install -p -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/%{service_name}-storage

install -dp %{buildroot}%{_mandir}/man{1,5,8}
install -m 644 docs/*.5 %{buildroot}%{_mandir}/man5
install -m 644 docs/*.8 %{buildroot}%{_mandir}/man8

mkdir -p %{buildroot}%{_sharedstatedir}/containers

# Common config from skopeo-containers
mkdir -p %{buildroot}/etc/containers
install -p -m 644 %{SOURCE5} %{buildroot}/etc/containers/policy.json

# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
%endif

%if 0%{?with_integration_tests}
install -d -p %{buildroot}/%{_datadir}/%{name}/test
cp -r test %{buildroot}/%{_datadir}/%{name}/

install -d -p %{buildroot}/etc/containers/registries.d
cp test/redhat_sigstore.yaml %{buildroot}/etc/containers/registries.d/registry.access.redhat.com.yaml
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%post
%systemd_post %{service_name}

%preun
%systemd_preun %{service_name}

%postun
%systemd_postun_with_restart %{service_name}

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE THIRD_PARTY_LICENSES.txt
%doc README.md code-of-conduct.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE THIRD_PARTY_LICENSES.txt
%doc README.md code-of-conduct.md
%endif

%if 0%{?with_integration_tests}
%files integration-tests
%license LICENSE THIRD_PARTY_LICENSES.txt
%doc README.md
%{_datadir}/%{name}/test/*
/etc/containers/registries.d/registry.access.redhat.com.yaml
%endif

%files
%license LICENSE THIRD_PARTY_LICENSES.txt
%{_sysconfdir}/crio/1.14
%doc README.md
%{_bindir}/%{service_name}
%{_mandir}/man5/%{service_name}.conf.5*
%{_mandir}/man8/%{service_name}.8*
%dir %{_sysconfdir}/%{service_name}
%config(noreplace) %{_sysconfdir}/%{service_name}/%{service_name}.conf
%config(noreplace) %{_sysconfdir}/%{service_name}/seccomp.json
%config(noreplace) %{_sysconfdir}/sysconfig/%{service_name}-storage
%config(noreplace) %{_sysconfdir}/sysconfig/%{service_name}-network
%config(noreplace) %{_sysconfdir}/cni/net.d/100-%{service_name}-bridge.conf
%config(noreplace) %{_sysconfdir}/cni/net.d/200-loopback.conf
%config(noreplace) %{_sysconfdir}/crictl.yaml
%dir %{_libexecdir}/%{service_name}
%{_libexecdir}/%{service_name}/pause
%{_unitdir}/%{service_name}.service
%{_unitdir}/cri-o.service
%{_unitdir}/%{service_name}-shutdown.service
%dir %{_sharedstatedir}/containers
%dir %{_datadir}/oci-umount
%dir %{_datadir}/oci-umount/oci-umount.d
%{_datadir}/oci-umount/oci-umount.d/%{service_name}-umount.conf
/etc/containers/policy.json

%files -n conmon
%license LICENSE THIRD_PARTY_LICENSES.txt
%doc README.md
%{_libexecdir}/%{service_name}/conmon

%changelog
* Fri Aug 14 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.14.7-1.0.8
- Address CVE-2020-16845

* Fri Feb 28 2020 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.14.7-1.0.7
- Enhance versioning detection

* Wed Jan 15 2020 Daniel Krasinski <daniel.krasinski@oracle.com> - 1.14.7-1.0.6
- added explicit dependency on cri-tools

* Wed Oct 30 2019 Daniel Krasinski <daniel.krasinski@oracle.com> - 1.14.7-1.0.5
- feature OCR forward

* Tue Oct 15 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.14.7-1.0.4
- Golang CVE-2019-16276

* Fri Oct 11 2019 Durai G <durai.vattakalvalasu.govindas@oracle.com> - 1.14.7-1.0.3
- added THIRD_PARTY_LICENSES.txt file

* Mon Aug 19 2019 Michael Calunod  <michael.calunod@oracle.com> - 1.14.7-1.0.2
- moved to semantic versioning for Release

* Sun Jul 14 2019 Olcne-Builder Jenkins <olcne-builder_us@oracle.com> - 1.14.7-1
- Added Oracle Specifile Files for cri-o
